#include <stdio.h>
#include <math.h>
#include <time.h>
// キーだけを持っている構造体（実際の運用の際は値を入れる)
// struct which only possess key (for actual use it has to have a value)
struct DATA{
	int key;
};
FILE *fp1,*fp2,*fp3;
struct DATA datas[1000000];
int max_dist = 0;
void MakeData(){
	int current_key= 0;
	int i;
	int tmp;
	for( i = 0;i<1000000;i++){
		datas[i].key = current_key;
		tmp= rand()%1000+1;
		// カンガルー法を適用するためには隣接するキーの値の差の最大値が必要
		// to apply the kangaro method maximum difference of the to adjoint key 
		max_dist = max_dist>tmp? max_dist : tmp;
		current_key += tmp;
	}	
}
void SimpleMethod(int tmpdata){
	int i;
	for( i = 0;i<1000000;i++){
		if(datas[i].key == tmpdata){
			fprintf(fp1,"%d\n",i);
			return;
		}
	}	
}
void KangarooMethod(int tmpdata){
	int i;
	int jump;
	int tmp;
	for( i = 0,tmp=0;i<1000000;){
			
		if(datas[i].key == tmpdata){
			fprintf(fp2,"%d\n",i);
			return;
		}
		// キーの値の差を隣同士のキーの値の差の最大値で割る
		// divide the difference of the key by the maximum difference of adjoint key
		jump = abs((tmpdata - datas[i].key))/max_dist;
		if(jump < 1) jump=1;
		i+=jump;	
	}	
}
// 言わずと知れた二分探索
void BinarySearch(int tmpdata){
	int left = 0, right = 999999;
	int mid;
	int tmp=0;
	while(left <= right){
		mid = (left+right)/2;
		if(datas[mid].key == tmpdata){
			fprintf(fp3,"%d\n",mid);
			return;
		}
		if(datas[mid].key<tmpdata){
			left = mid+1;
		}else{
			right = mid -1;
		}
	}	
}
int main(){
	int t1,t2;
	int i;
	int tmpdata[10000];
	fp1 = fopen("tmp","w");
	fp2 = fopen("tmp2","w");
	fp3 = fopen("tmp3","w");
	MakeData();	
	// サーチするデータを10000個生成
	// Make the data for which to search
	for(i=0;i<10000;i++){
		tmpdata[i] = datas[rand()%1000000].key;
	}
	t1 = clock();
	for(i=0;i<10000;i++){
		SimpleMethod(tmpdata[i]);
	}
	t2 = clock();
	printf("time1 = %f[s]\n", (double)(t2-t1)/CLOCKS_PER_SEC);
	t1 = clock();
	for(i=0;i<10000;i++){
		KangarooMethod(tmpdata[i]);
	}
	t2 = clock();
	printf("time2 = %f[s]\n", (double)(t2-t1)/CLOCKS_PER_SEC);
	t1 = clock();
	for(i=0;i<10000;i++){
		BinarySearch(tmpdata[i]);
	}
	t2 = clock();
	printf("time3 = %f[s]\n", (double)(t2-t1)/CLOCKS_PER_SEC);
	fclose(fp1);
	fclose(fp2);
	fclose(fp3);
}
